najjar.biz/Models/ExamSystemModels/Question.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace najjar.biz.Models
{
    public class Question
    {
        [Key]
        public int Id { get; set; }

        public int CategoryId { get; set; }

        // Points Assigned to the Question
        public double points { get; set; }

        // The type of Question (Single Choice, Multiple Choice, Text Area...)
        public string QuestionType { get; set;}

        public string QuestionText { get; set; }

        public bool IsActive { get; set; }

        // Navigation Properties...

        // Every Question belongs to a property
        public QuestionCategory QuestionCategory { get; set; }

        // Every Test Contains Multiple Questions, and Every Question might belong to several Tests...
        public List<TestXQuestion> TestXQuestion { get; set; }

        public List<Choice> Choices { get; set; }
    }
}

najjar.biz/Controllers/QuestionController.cs
using Microsoft.AspNet.Identity;
using Microsoft.AspNet.Identity.EntityFramework;
using najjar.biz.Context;
using najjar.biz.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;

namespace najjar.biz.Controllers
{
    public class QuestionController : Controller
    {
        private ApplicationDataContext db = new ApplicationDataContext();

        // GET: /Question/
        public ActionResult Index()
        {
            fillUserData();
            return View(db.Questions.ToList());
        }

        // GET: /Question/Details/5
        public ActionResult Details(int? id)
        {
            fillUserData();
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Question question = db.Questions.Find(id);
            if (question == null)
            {
                return HttpNotFound();
            }
            return View(question);
        }

        public ActionResult QuestionPage(int TestId)
        {
            fillUserData();
            Test test = db
                .Tests
                .Include("TestXQuestions")
                .Include("TestXQuestions.Question")
                .Include("TestXQuestions.Question.Choices")
                .Where(t => t.Id == TestId)
                .FirstOrDefault();

            if (test != null)
            {
                return View(test);

            }
            else
            {
                return View("Error");
            }
        }

        [HttpGet]
        public ActionResult AddNewQuestion(int TestId)
        {
            fillUserData();
            Test test = db.Tests.FirstOrDefault(t => t.Id == TestId);

            if (test != null)
            {
                ViewBag.Categories = new SelectList(db.QuestionCategories.ToList(), "Id", "Category");
                ViewBag.Test = test;

                return View();
            }
            else
            {
                return View("Error");
            }

        }

        [HttpPost]
        public ActionResult AddNewQuestion(Question question, int TestId)
        {
            fillUserData();
            if (ModelState.IsValid)
            {
                string category = db
                    .QuestionCategories
                    .Where(cat => cat.Id == question.CategoryId)
                    .Select(cat => cat.Category)
                    .FirstOrDefault();

                question.QuestionType = category;

                int nextQuestionNumber = db
                        .TestXQuestions
                        .Where(txq => txq.TestId == TestId)
                        .Count() + 1;

                db.Questions.Add(question);
                db.SaveChanges();

                Question lastInsertedQuestion = db
                    .Questions
                    .OrderByDescending(q => q.Id)
                    .FirstOrDefault();

                TestXQuestion testXQuestion = new TestXQuestion()
                {
                    TestId = TestId,
                    QuestionId = lastInsertedQuestion.Id,
                    QuestionNumber = nextQuestionNumber,
                    IsActive = question.IsActive
                };

                db.TestXQuestions.Add(testXQuestion);

                db.SaveChanges();

                return RedirectToAction("QuestionPage", new { TestId });
            }

            // if an Error Occurred!

            Test test = db.Tests.FirstOrDefault(t => t.Id == TestId);

            if (test != null)
            {
                ViewBag.Categories = new SelectList(db.QuestionCategories.ToList(), "Id", "Category");
                ViewBag.Test = test;
            }

            return View(question);
        }
        [HttpGet]
        public ActionResult Edit(int QuestionId, int TestId)
        {
            fillUserData();
            Question question = db.Questions.Find(QuestionId);
            Test test = db.Tests.Where(t => t.Id == TestId).FirstOrDefault();

            if (question != null && test != null)
            {
                ViewBag.Categories = new SelectList(db.QuestionCategories.ToList(), "Id", "Category");
                ViewBag.Test = test;
                return View(question);
            }
            else
            {
                return HttpNotFound("The Question with the Question Id: " +
                    QuestionId +
                    " Couldn't be found! Or The Test with TestId: "
                    + TestId + " couldn't be found!");
            }
        }
        // GET: /Question/Delete/5
        public ActionResult Delete(int? id)
        {
            fillUserData();
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Question question = db.Questions.Find(id);
            if (question == null)
            {
                return HttpNotFound();
            }
            return View(question);
        }

        // POST: /Question/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            fillUserData();
            Question question = db.Questions.Find(id);
            db.Questions.Remove(question);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        [HttpPost]
        public ActionResult Edit(Question question, int TestId)
        {
            fillUserData();
            if (ModelState.IsValid)
            {
                Question questionToUpdate = db
                    .Questions
                    .Where(q => q.Id == question.Id)
                    .FirstOrDefault();
                TryUpdateModel(questionToUpdate);

                questionToUpdate.QuestionType = db
                    .QuestionCategories
                    .Where(cat => cat.Id == question.CategoryId)
                    .Select(cat => cat.Category)
                    .FirstOrDefault();

                db.Entry(questionToUpdate).State = System.Data.Entity.EntityState.Modified;

                db.SaveChanges();

                return RedirectToAction("QuestionPage", new { TestId });
            }
            else
            {
                ViewBag.Test = db
                    .Tests
                    .Where(t => t.Id == TestId)
                    .FirstOrDefault();
                return View(question);
            }
        }


        public void fillUserData()
        {
            var userManager = new UserManager<ApplicationUser>(new UserStore<ApplicationUser>(new ApplicationDataContext()));
            var user = userManager.FindById(User.Identity.GetUserId());
            ViewBag.CurrentUser = user;
        }
    }
}

najjar.biz/Views/Question/AddNewQuestion.cshtml
@using najjar.biz.Models
@model najjar.biz.Models.Question

@{
    ViewBag.Title = "AddNewQuestion";
    Test test = (Test)ViewBag.Test;
}

<div class="row">
    <div class="col-xs-12 text-center">
        <h2>Add Questions for @test.Name</h2>
    </div>
</div>

@using (Html.BeginForm("AddNewQuestion", "Question", FormMethod.Post))
{
    @Html.Hidden("TestId", test.Id)

<div class="row">
    <div class="form-group">
        <label class="control-label col-xs-12 col-sm-2">
            Question Text:
        </label>
        <div class="col-xs-12 col-sm-10">
            @Html.TextAreaFor(model => model.QuestionText, new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.QuestionText,"",
                    new { @class="text-danger" })
        </div>
    </div>
</div>
<div class="row">
    <div class="form-group">
        <label class="control-label col-xs-12 col-sm-2">
            Question Points:
        </label>
        <div class="col-xs-12 col-sm-10">
            @Html.TextBoxFor(model => model.points, new { @class = "form-control", @type = "number" })
            @Html.ValidationMessageFor(model => model.points,"",
                    new { @class="text-danger" })
        </div>
    </div>
</div>
<div class="row">
    <div class="form-group">
        <label class="control-label col-xs-12 col-sm-2">
            Question Category:
        </label>
        <div class="col-xs-12 col-sm-10">
            @Html.DropDownListFor(model => model.CategoryId, (SelectList)ViewBag.Categories, "Please Select a Category", new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.QuestionText,"",
                    new { @class="text-danger" })
        </div>
    </div>
</div>
    <div class="row">
        <div class="col-xs-10 col-xs-offset-2">
            <div class="checkbox">
                <label>
                    @Html.CheckBoxFor(model => model.IsActive, new { @checked = "checked" })
                    Is Active
                </label>
            </div>
        </div>
    </div>
<div class="row">
    <input type="submit" value="Add New Question" class="btn btn-primary" />
</div>
}

najjar.biz/Views/Question/Create.cshtml
@model najjar.biz.Models.Question

@{
    ViewBag.Title = "Create";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Create</h2>


@using (Html.BeginForm()) 
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>Question</h4>
        <hr />
        @Html.ValidationSummary(true)

        <div class="form-group">
            @Html.LabelFor(model => model.CategoryId, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.CategoryId)
                @Html.ValidationMessageFor(model => model.CategoryId)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.points, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.points)
                @Html.ValidationMessageFor(model => model.points)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.QuestionType, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.QuestionType)
                @Html.ValidationMessageFor(model => model.QuestionType)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.QuestionText, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.QuestionText)
                @Html.ValidationMessageFor(model => model.QuestionText)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.IsActive, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.IsActive)
                @Html.ValidationMessageFor(model => model.IsActive)
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Create" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

<script src="~/Scripts/jquery-1.10.2.min.js"></script>
<script src="~/Scripts/jquery.validate.min.js"></script>
<script src="~/Scripts/jquery.validate.unobtrusive.min.js"></script>

najjar.biz/Views/Question/Delete.cshtml
@model najjar.biz.Models.Question

@{
    ViewBag.Title = "Delete";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Question</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.CategoryId)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.CategoryId)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.points)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.points)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.QuestionType)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.QuestionType)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.QuestionText)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.QuestionText)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.IsActive)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.IsActive)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            @Html.ActionLink("Back to List", "Index")
        </div>
    }
</div>

najjar.biz/Views/Question/Details.cshtml
@model najjar.biz.Models.Question

@{
    ViewBag.Title = "Details";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Details</h2>

<div>
    <h4>Question</h4>
	<hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.CategoryId)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.CategoryId)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.points)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.points)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.QuestionType)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.QuestionType)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.QuestionText)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.QuestionText)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.IsActive)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.IsActive)
        </dd>

    </dl>
</div>
<p>
    @Html.ActionLink("Edit", "Edit", new { id = Model.Id }) |
    @Html.ActionLink("Back to List", "Index")
</p>

najjar.biz/Views/Question/Edit.cshtml
@model najjar.biz.Models.Question
@using najjar.biz.Models

@{
    ViewBag.Title = "AddNewQuestion";
    Test test = ((Test)ViewBag.Test);
}

<div class="row">
    <div class="col-xs-12 text-center">
        <h2>Add Questions for @test.Name</h2>
    </div>
</div>

@using (Html.BeginForm("Edit", "Question", FormMethod.Post))
{
    @Html.HiddenFor(model => model.Id) // QuestionId
    @Html.Hidden("TestId", test.Id) // TestId

    <div class="row">
        <div class="form-group">
            <label class="control-label col-xs-12 col-sm-2">
                Question Text:
            </label>
            <div class="col-xs-12 col-sm-10">
                @Html.TextAreaFor(model => model.QuestionText, new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.QuestionText,"",
                        new { @class="text-danger" })
            </div>
        </div>
    </div>
    <div class="row">
        <div class="form-group">
            <label class="control-label col-xs-12 col-sm-2">
                Question Points:
            </label>
            <div class="col-xs-12 col-sm-10">
                @Html.TextBoxFor(model => model.points, new { @class = "form-control", @type = "number" })
                @Html.ValidationMessageFor(model => model.points,"",
                        new { @class="text-danger" })
            </div>
        </div>
    </div>
    <div class="row">
        <div class="form-group">
            <label class="control-label col-xs-12 col-sm-2">
                Question Category:
            </label>
            <div class="col-xs-12 col-sm-10">
                @Html.DropDownListFor(model => model.CategoryId,(SelectList)ViewBag.Categories, "Please Select a Category",new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.QuestionText,"",
                        new { @class="text-danger" })
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-10 col-xs-offset-2">
            <div class="checkbox">
                <label>
                    @Html.CheckBoxFor(model => model.IsActive, new { @checked = "checked" })
                    Is Active
                </label>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-offset-2 col-xs-10">
            <input type="submit" value="Edit" class="btn btn-default" />
        </div>
    </div>
}

najjar.biz/Views/Question/Index.cshtml
@model IEnumerable<najjar.biz.Models.Question>

@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Index</h2>

<p>
    @Html.ActionLink("Create New", "Create")
</p>
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.CategoryId)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.points)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.QuestionType)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.QuestionText)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.IsActive)
        </th>
        <th></th>
    </tr>

@foreach (var item in Model) {
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.CategoryId)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.points)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.QuestionType)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.QuestionText)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.IsActive)
        </td>
        <td>
            @Html.ActionLink("Edit", "Edit", new { id=item.Id }) |
            @Html.ActionLink("Details", "Details", new { id=item.Id }) |
            @Html.ActionLink("Delete", "Delete", new { id=item.Id })
        </td>
    </tr>
}

</table>

najjar.biz/Views/Question/QuestionPage.cshtml
@model najjar.biz.Models.Test

@{
    ViewBag.Title = "QuestionPage for " + Model.Name;
    var testXQuestions = Model.TestXQuestions;
}

<div class="row text-center">
    <div class="col-xs-12">
        <h2>Question Page for @Model.Name</h2>
    </div>
</div>

<div class="row text-center">
    <div class="col-xs-12">
        @Html.ActionLink("Add New Question", "AddNewQuestion", "Question",
            new { TestId = Model.Id }, new { @class="btn btn-default" })
    </div>
</div>

@while (testXQuestions.Count() > 0)
{
    <div class="row">
        @foreach (var item in testXQuestions.Take(2))
        {
            <div class="col-xs-12 col-sm-6">
                <div class="row">
                    <div class="col-xs-2">
                        <h3>@item.QuestionNumber&sdot;</h3>&nbsp;
                    </div>
                    <div class="col-xs-5">
                        <strong>@item.Question.QuestionText</strong>
                    </div>
                    <div class="col-xs-5">
                        <p class="text-success">
                            @item.Question.points&nbsp;Points
                        </p>
                    </div>
                </div>
                <div class="row">
                    <div class=" col-xs-offset-1 col-xs-10">
                        @foreach (var choice in item.Question.Choices)
                        {
                            if (item.Question.QuestionType.Equals("single_choice", 
                                StringComparison.InvariantCultureIgnoreCase))
                            {
                                <div class="radio">
                                    <label style="overflow-wrap:break-word">
                                        <input type="radio" disabled />
                                        @choice.Label
                                    </label>
                                    &nbsp;
                                    <span class="text-success">
                                        @choice.points&nbsp;Points
                                    </span>
                                    &nbsp;|&nbsp;
                                    @Html.ActionLink("Edit", "Edit", "Choice",
                                        new { ChoiceId = choice.Id, QuestionId = item.QuestionId }, null)
                                </div>
                            }
                            else
                            {
                                <div class="checkbox">
                                    <label style="overflow-wrap:break-word">
                                        <input type="checkbox" disabled />
                                        @choice.Label
                                    </label>
                                    <span class="text-success">
                                        @choice.points&nbsp;Points
                                    </span>
                                    &nbsp;|&nbsp;
                                    @Html.ActionLink("Edit", "Edit", "Choice",
                                        new { ChoiceId = choice.Id, QuestionId = item.QuestionId }, null)
                                </div>
                            }
                        }
                    </div>
                </div>
                <div class="row">
                    <div class="col-xs-10 col-xs-offset-2">
                        @Html.ActionLink("Add new Choice", "AddNewChoice", "Choice",
                            new { QuestionId = item.QuestionId }, null)&nbsp;|&nbsp;
                        @Html.ActionLink("Edit This Question", "Edit", "Question",
                            new { QuestionId = item.QuestionId, TestId = Model.Id}, null)
                    </div>
                </div>
            </div>
        }
    </div>
    testXQuestions = testXQuestions.Skip(2).ToList();
}